
local E_MODEL_TROLLFACE = smlua_model_util_get_id("trollface_geo")

local TEXT_MOD_NAME = "Trollface"

local TEX_TROLLFACE = get_texture_info("trollface-icon")

local ANIMTABLE_TROLLFACE = {
    --[[
    [CHAR_ANIM_SLOW_LEDGE_GRAB] = "CHAR_ANIM_SLOW_LEDGE_GRAB",
    [CHAR_ANIM_FALL_OVER_BACKWARDS] = "CHAR_ANIM_FALL_OVER_BACKWARDS",
    [CHAR_ANIM_BACKWARD_AIR_KB] = "CHAR_ANIM_BACKWARD_AIR_KB",
    [CHAR_ANIM_DYING_ON_BACK] = "CHAR_ANIM_DYING_ON_BACK",
    [CHAR_ANIM_BACKFLIP] = "CHAR_ANIM_BACKFLIP",
    [CHAR_ANIM_CLIMB_UP_POLE] = "CHAR_ANIM_CLIMB_UP_POLE",
    [CHAR_ANIM_GRAB_POLE_SHORT] = "CHAR_ANIM_GRAB_POLE_SHORT",
    [CHAR_ANIM_GRAB_POLE_SWING_PART1] = "CHAR_ANIM_GRAB_POLE_SWING_PART1",
    [CHAR_ANIM_GRAB_POLE_SWING_PART2] = "CHAR_ANIM_GRAB_POLE_SWING_PART2",
    [CHAR_ANIM_HANDSTAND_IDLE] = "CHAR_ANIM_HANDSTAND_IDLE",
    [CHAR_ANIM_HANDSTAND_JUMP] = "CHAR_ANIM_HANDSTAND_JUMP",
    [CHAR_ANIM_START_HANDSTAND] = "CHAR_ANIM_START_HANDSTAND",
    [CHAR_ANIM_RETURN_FROM_HANDSTAND] = "CHAR_ANIM_RETURN_FROM_HANDSTAND",
    [CHAR_ANIM_IDLE_ON_POLE] = "CHAR_ANIM_IDLE_ON_POLE",
    [CHAR_ANIM_A_POSE] = "CHAR_ANIM_A_POSE",
    [CHAR_ANIM_SKID_ON_GROUND] = "CHAR_ANIM_SKID_ON_GROUND",
    [CHAR_ANIM_STOP_SKID] = "CHAR_ANIM_STOP_SKID",
    [CHAR_ANIM_CROUCH_FROM_FAST_LONGJUMP] = "CHAR_ANIM_CROUCH_FROM_FAST_LONGJUMP",
    [CHAR_ANIM_CROUCH_FROM_SLOW_LONGJUMP] = "CHAR_ANIM_CROUCH_FROM_SLOW_LONGJUMP",
    [CHAR_ANIM_FAST_LONGJUMP] = "CHAR_ANIM_FAST_LONGJUMP",
    [CHAR_ANIM_SLOW_LONGJUMP] = "CHAR_ANIM_SLOW_LONGJUMP",
    [CHAR_ANIM_AIRBORNE_ON_STOMACH] = "CHAR_ANIM_AIRBORNE_ON_STOMACH",
    [CHAR_ANIM_WALK_WITH_LIGHT_OBJ] = "CHAR_ANIM_WALK_WITH_LIGHT_OBJ",
    [CHAR_ANIM_RUN_WITH_LIGHT_OBJ] = "CHAR_ANIM_RUN_WITH_LIGHT_OBJ",
    [CHAR_ANIM_SLOW_WALK_WITH_LIGHT_OBJ] = "CHAR_ANIM_SLOW_WALK_WITH_LIGHT_OBJ",
    [CHAR_ANIM_SHIVERING_WARMING_HAND] = "CHAR_ANIM_SHIVERING_WARMING_HAND",
    [CHAR_ANIM_SHIVERING_RETURN_TO_IDLE] = "CHAR_ANIM_SHIVERING_RETURN_TO_IDLE",
    [CHAR_ANIM_SHIVERING] = "CHAR_ANIM_SHIVERING",
    [CHAR_ANIM_CLIMB_DOWN_LEDGE] = "CHAR_ANIM_CLIMB_DOWN_LEDGE",
    [CHAR_ANIM_CREDITS_WAVING] = "CHAR_ANIM_CREDITS_WAVING",
    [CHAR_ANIM_CREDITS_LOOK_UP] = "CHAR_ANIM_CREDITS_LOOK_UP",
    [CHAR_ANIM_CREDITS_RETURN_FROM_LOOK_UP] = "CHAR_ANIM_CREDITS_RETURN_FROM_LOOK_UP",
    [CHAR_ANIM_CREDITS_RAISE_HAND] = "CHAR_ANIM_CREDITS_RAISE_HAND",
    [CHAR_ANIM_CREDITS_LOWER_HAND] = "CHAR_ANIM_CREDITS_LOWER_HAND",
    [CHAR_ANIM_CREDITS_TAKE_OFF_CAP] = "CHAR_ANIM_CREDITS_TAKE_OFF_CAP",
    [CHAR_ANIM_CREDITS_START_WALK_LOOK_UP] = "CHAR_ANIM_CREDITS_START_WALK_LOOK_UP",
    [CHAR_ANIM_CREDITS_LOOK_BACK_THEN_RUN] = "CHAR_ANIM_CREDITS_LOOK_BACK_THEN_RUN",
    [CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN] = "CHAR_ANIM_FINAL_BOWSER_RAISE_HAND_SPIN",
    [CHAR_ANIM_FINAL_BOWSER_WING_CAP_TAKE_OFF] = "CHAR_ANIM_FINAL_BOWSER_WING_CAP_TAKE_OFF",
    [CHAR_ANIM_CREDITS_PEACE_SIGN] = "CHAR_ANIM_CREDITS_PEACE_SIGN",
    [CHAR_ANIM_STAND_UP_FROM_LAVA_BOOST] = "CHAR_ANIM_STAND_UP_FROM_LAVA_BOOST",
    [CHAR_ANIM_FIRE_LAVA_BURN] = "CHAR_ANIM_FIRE_LAVA_BURN",
    [CHAR_ANIM_WING_CAP_FLY] = "CHAR_ANIM_WING_CAP_FLY",
    [CHAR_ANIM_HANG_ON_OWL] = "CHAR_ANIM_HANG_ON_OWL",
    [CHAR_ANIM_LAND_ON_STOMACH] = "CHAR_ANIM_LAND_ON_STOMACH",
    [CHAR_ANIM_AIR_FORWARD_KB] = "CHAR_ANIM_AIR_FORWARD_KB",
    [CHAR_ANIM_DYING_ON_STOMACH] = "CHAR_ANIM_DYING_ON_STOMACH",
    [CHAR_ANIM_SUFFOCATING] = "CHAR_ANIM_SUFFOCATING",
    [CHAR_ANIM_COUGHING] = "CHAR_ANIM_COUGHING",
    [CHAR_ANIM_THROW_CATCH_KEY] = "CHAR_ANIM_THROW_CATCH_KEY",
    [CHAR_ANIM_DYING_FALL_OVER] = "CHAR_ANIM_DYING_FALL_OVER",
    [CHAR_ANIM_IDLE_ON_LEDGE] = "CHAR_ANIM_IDLE_ON_LEDGE",
    [CHAR_ANIM_FAST_LEDGE_GRAB] = "CHAR_ANIM_FAST_LEDGE_GRAB",
    [CHAR_ANIM_HANG_ON_CEILING] = "CHAR_ANIM_HANG_ON_CEILING",
    [CHAR_ANIM_PUT_CAP_ON] = "CHAR_ANIM_PUT_CAP_ON",
    --]]
    [CHAR_ANIM_TAKE_CAP_OFF_THEN_ON] = "TROLLFACE_ANIM_PAIN",
    --[[
    [CHAR_ANIM_QUICKLY_PUT_CAP_ON] = "CHAR_ANIM_QUICKLY_PUT_CAP_ON",
    [CHAR_ANIM_HEAD_STUCK_IN_GROUND] = "CHAR_ANIM_HEAD_STUCK_IN_GROUND",
    [CHAR_ANIM_GROUND_POUND_LANDING] = "CHAR_ANIM_GROUND_POUND_LANDING",
    [CHAR_ANIM_TRIPLE_JUMP_GROUND_POUND] = "CHAR_ANIM_TRIPLE_JUMP_GROUND_POUND",
    [CHAR_ANIM_START_GROUND_POUND] = "CHAR_ANIM_START_GROUND_POUND",
    [CHAR_ANIM_GROUND_POUND] = "CHAR_ANIM_GROUND_POUND",
    [CHAR_ANIM_BOTTOM_STUCK_IN_GROUND] = "CHAR_ANIM_BOTTOM_STUCK_IN_GROUND",
    [CHAR_ANIM_IDLE_WITH_LIGHT_OBJ] = "CHAR_ANIM_IDLE_WITH_LIGHT_OBJ",
    [CHAR_ANIM_JUMP_LAND_WITH_LIGHT_OBJ] = "CHAR_ANIM_JUMP_LAND_WITH_LIGHT_OBJ",
    [CHAR_ANIM_JUMP_WITH_LIGHT_OBJ] = "CHAR_ANIM_JUMP_WITH_LIGHT_OBJ",
    [CHAR_ANIM_FALL_LAND_WITH_LIGHT_OBJ] = "CHAR_ANIM_FALL_LAND_WITH_LIGHT_OBJ",
    [CHAR_ANIM_FALL_WITH_LIGHT_OBJ] = "CHAR_ANIM_FALL_WITH_LIGHT_OBJ",
    [CHAR_ANIM_FALL_FROM_SLIDING_WITH_LIGHT_OBJ] = "CHAR_ANIM_FALL_FROM_SLIDING_WITH_LIGHT_OBJ",
    [CHAR_ANIM_SLIDING_ON_BOTTOM_WITH_LIGHT_OBJ] = "CHAR_ANIM_SLIDING_ON_BOTTOM_WITH_LIGHT_OBJ",
    [CHAR_ANIM_STAND_UP_FROM_SLIDING_WITH_LIGHT_OBJ] = "CHAR_ANIM_STAND_UP_FROM_SLIDING_WITH_LIGHT_OBJ",
    [CHAR_ANIM_RIDING_SHELL] = "CHAR_ANIM_RIDING_SHELL",
    [CHAR_ANIM_WALKING] = "CHAR_ANIM_WALKING",
    [CHAR_ANIM_FORWARD_FLIP] = "CHAR_ANIM_FORWARD_FLIP",
    [CHAR_ANIM_JUMP_RIDING_SHELL] = "CHAR_ANIM_JUMP_RIDING_SHELL",
    [CHAR_ANIM_LAND_FROM_DOUBLE_JUMP] = "CHAR_ANIM_LAND_FROM_DOUBLE_JUMP",
    [CHAR_ANIM_DOUBLE_JUMP_FALL] = "CHAR_ANIM_DOUBLE_JUMP_FALL",
    [CHAR_ANIM_SINGLE_JUMP] = "CHAR_ANIM_SINGLE_JUMP",
    [CHAR_ANIM_LAND_FROM_SINGLE_JUMP] = "CHAR_ANIM_LAND_FROM_SINGLE_JUMP",
    [CHAR_ANIM_AIR_KICK] = "CHAR_ANIM_AIR_KICK",
    [CHAR_ANIM_DOUBLE_JUMP_RISE] = "CHAR_ANIM_DOUBLE_JUMP_RISE",
    [CHAR_ANIM_START_FORWARD_SPINNING] = "CHAR_ANIM_START_FORWARD_SPINNING",
    [CHAR_ANIM_THROW_LIGHT_OBJECT] = "CHAR_ANIM_THROW_LIGHT_OBJECT",
    [CHAR_ANIM_FALL_FROM_SLIDE_KICK] = "CHAR_ANIM_FALL_FROM_SLIDE_KICK",
    [CHAR_ANIM_BEND_KNESS_RIDING_SHELL] = "CHAR_ANIM_BEND_KNESS_RIDING_SHELL",
    [CHAR_ANIM_LEGS_STUCK_IN_GROUND] = "CHAR_ANIM_LEGS_STUCK_IN_GROUND",
    [CHAR_ANIM_GENERAL_FALL] = "CHAR_ANIM_GENERAL_FALL",
    [CHAR_ANIM_GENERAL_LAND] = "CHAR_ANIM_GENERAL_LAND",
    [CHAR_ANIM_BEING_GRABBED] = "CHAR_ANIM_BEING_GRABBED",
    [CHAR_ANIM_GRAB_HEAVY_OBJECT] = "CHAR_ANIM_GRAB_HEAVY_OBJECT",
    [CHAR_ANIM_SLOW_LAND_FROM_DIVE] = "CHAR_ANIM_SLOW_LAND_FROM_DIVE",
    [CHAR_ANIM_FLY_FROM_CANNON] = "CHAR_ANIM_FLY_FROM_CANNON",
    [CHAR_ANIM_MOVE_ON_WIRE_NET_RIGHT] = "CHAR_ANIM_MOVE_ON_WIRE_NET_RIGHT",
    [CHAR_ANIM_MOVE_ON_WIRE_NET_LEFT] = "CHAR_ANIM_MOVE_ON_WIRE_NET_LEFT",
    [CHAR_ANIM_MISSING_CAP] = "CHAR_ANIM_MISSING_CAP",
    [CHAR_ANIM_PULL_DOOR_WALK_IN] = "CHAR_ANIM_PULL_DOOR_WALK_IN",
    [CHAR_ANIM_PUSH_DOOR_WALK_IN] = "CHAR_ANIM_PUSH_DOOR_WALK_IN",
    [CHAR_ANIM_UNLOCK_DOOR] = "CHAR_ANIM_UNLOCK_DOOR",
    [CHAR_ANIM_START_REACH_POCKET] = "CHAR_ANIM_START_REACH_POCKET",
    [CHAR_ANIM_REACH_POCKET] = "CHAR_ANIM_REACH_POCKET",
    [CHAR_ANIM_STOP_REACH_POCKET] = "CHAR_ANIM_STOP_REACH_POCKET",
    [CHAR_ANIM_GROUND_THROW] = "CHAR_ANIM_GROUND_THROW",
    [CHAR_ANIM_GROUND_KICK] = "CHAR_ANIM_GROUND_KICK",
    [CHAR_ANIM_FIRST_PUNCH] = "CHAR_ANIM_FIRST_PUNCH",
    [CHAR_ANIM_SECOND_PUNCH] = "CHAR_ANIM_SECOND_PUNCH",
    [CHAR_ANIM_FIRST_PUNCH_FAST] = "CHAR_ANIM_FIRST_PUNCH_FAST",
    [CHAR_ANIM_SECOND_PUNCH_FAST] = "CHAR_ANIM_SECOND_PUNCH_FAST",
    [CHAR_ANIM_PICK_UP_LIGHT_OBJ] = "CHAR_ANIM_PICK_UP_LIGHT_OBJ",
    [CHAR_ANIM_PUSHING] = "CHAR_ANIM_PUSHING",
    [CHAR_ANIM_START_RIDING_SHELL] = "CHAR_ANIM_START_RIDING_SHELL",
    [CHAR_ANIM_PLACE_LIGHT_OBJ] = "CHAR_ANIM_PLACE_LIGHT_OBJ",
    [CHAR_ANIM_FORWARD_SPINNING] = "CHAR_ANIM_FORWARD_SPINNING",
    [CHAR_ANIM_BACKWARD_SPINNING] = "CHAR_ANIM_BACKWARD_SPINNING",
    [CHAR_ANIM_BREAKDANCE] = "CHAR_ANIM_BREAKDANCE",
    --]]
    [MARIO_ANIM_RUNNING] = "TROLLFACE_ANIM_RUNNING",
    --[[
    [CHAR_ANIM_RUNNING_UNUSED] = "CHAR_ANIM_RUNNING_UNUSED",
    [CHAR_ANIM_SOFT_BACK_KB] = "CHAR_ANIM_SOFT_BACK_KB",
    [CHAR_ANIM_SOFT_FRONT_KB] = "CHAR_ANIM_SOFT_FRONT_KB",
    [CHAR_ANIM_DYING_IN_QUICKSAND] = "CHAR_ANIM_DYING_IN_QUICKSAND",
    [CHAR_ANIM_IDLE_IN_QUICKSAND] = "CHAR_ANIM_IDLE_IN_QUICKSAND",
    [CHAR_ANIM_MOVE_IN_QUICKSAND] = "CHAR_ANIM_MOVE_IN_QUICKSAND",
    [CHAR_ANIM_ELECTROCUTION] = "CHAR_ANIM_ELECTROCUTION",
    [CHAR_ANIM_SHOCKED] = "CHAR_ANIM_SHOCKED",
    [CHAR_ANIM_BACKWARD_KB] = "CHAR_ANIM_BACKWARD_KB",
    [CHAR_ANIM_FORWARD_KB] = "CHAR_ANIM_FORWARD_KB",
    [CHAR_ANIM_IDLE_HEAVY_OBJ] = "CHAR_ANIM_IDLE_HEAVY_OBJ",
    [CHAR_ANIM_STAND_AGAINST_WALL] = "CHAR_ANIM_STAND_AGAINST_WALL",
    [CHAR_ANIM_SIDESTEP_LEFT] = "CHAR_ANIM_SIDESTEP_LEFT",
    [CHAR_ANIM_SIDESTEP_RIGHT] = "CHAR_ANIM_SIDESTEP_RIGHT",
    [CHAR_ANIM_START_SLEEP_IDLE] = "CHAR_ANIM_START_SLEEP_IDLE",
    [CHAR_ANIM_START_SLEEP_SCRATCH] = "CHAR_ANIM_START_SLEEP_SCRATCH",
    [CHAR_ANIM_START_SLEEP_YAWN] = "CHAR_ANIM_START_SLEEP_YAWN",
    [CHAR_ANIM_START_SLEEP_SITTING] = "CHAR_ANIM_START_SLEEP_SITTING",
    [CHAR_ANIM_SLEEP_IDLE] = "CHAR_ANIM_SLEEP_IDLE",
    [CHAR_ANIM_SLEEP_START_LYING] = "CHAR_ANIM_SLEEP_START_LYING",
    [CHAR_ANIM_SLEEP_LYING] = "CHAR_ANIM_SLEEP_LYING",
    [CHAR_ANIM_DIVE] = "CHAR_ANIM_DIVE",
    [CHAR_ANIM_SLIDE_DIVE] = "CHAR_ANIM_SLIDE_DIVE",
    [CHAR_ANIM_GROUND_BONK] = "CHAR_ANIM_GROUND_BONK",
    [CHAR_ANIM_STOP_SLIDE_LIGHT_OBJ] = "CHAR_ANIM_STOP_SLIDE_LIGHT_OBJ",
    [CHAR_ANIM_SLIDE_KICK] = "CHAR_ANIM_SLIDE_KICK",
    [CHAR_ANIM_CROUCH_FROM_SLIDE_KICK] = "CHAR_ANIM_CROUCH_FROM_SLIDE_KICK",
    [CHAR_ANIM_SLIDE_MOTIONLESS] = "CHAR_ANIM_SLIDE_MOTIONLESS",
    [CHAR_ANIM_STOP_SLIDE] = "CHAR_ANIM_STOP_SLIDE",
    [CHAR_ANIM_FALL_FROM_SLIDE] = "CHAR_ANIM_FALL_FROM_SLIDE",
    [CHAR_ANIM_SLIDE] = "CHAR_ANIM_SLIDE",
    [CHAR_ANIM_TIPTOE] = "CHAR_ANIM_TIPTOE",
    [CHAR_ANIM_TWIRL_LAND] = "CHAR_ANIM_TWIRL_LAND",
    [CHAR_ANIM_TWIRL] = "CHAR_ANIM_TWIRL",
    [CHAR_ANIM_START_TWIRL] = "CHAR_ANIM_START_TWIRL",
    [CHAR_ANIM_STOP_CROUCHING] = "CHAR_ANIM_STOP_CROUCHING",
    [CHAR_ANIM_START_CROUCHING] = "CHAR_ANIM_START_CROUCHING",
    [CHAR_ANIM_CROUCHING] = "CHAR_ANIM_CROUCHING",
    [CHAR_ANIM_CRAWLING] = "CHAR_ANIM_CRAWLING",
    [CHAR_ANIM_STOP_CRAWLING] = "CHAR_ANIM_STOP_CRAWLING",
    [CHAR_ANIM_START_CRAWLING] = "CHAR_ANIM_START_CRAWLING",
    [CHAR_ANIM_SUMMON_STAR] = "CHAR_ANIM_SUMMON_STAR",
    [CHAR_ANIM_RETURN_STAR_APPROACH_DOOR] = "CHAR_ANIM_RETURN_STAR_APPROACH_DOOR",
    [CHAR_ANIM_BACKWARDS_WATER_KB] = "CHAR_ANIM_BACKWARDS_WATER_KB",
    [CHAR_ANIM_SWIM_WITH_OBJ_PART1] = "CHAR_ANIM_SWIM_WITH_OBJ_PART1",
    [CHAR_ANIM_SWIM_WITH_OBJ_PART2] = "CHAR_ANIM_SWIM_WITH_OBJ_PART2",
    [CHAR_ANIM_FLUTTERKICK_WITH_OBJ] = "CHAR_ANIM_FLUTTERKICK_WITH_OBJ",
    [CHAR_ANIM_WATER_ACTION_END_WITH_OBJ] = "CHAR_ANIM_WATER_ACTION_END_WITH_OBJ",
    [CHAR_ANIM_STOP_GRAB_OBJ_WATER] = "CHAR_ANIM_STOP_GRAB_OBJ_WATER",
    [CHAR_ANIM_WATER_IDLE_WITH_OBJ] = "CHAR_ANIM_WATER_IDLE_WITH_OBJ",
    [CHAR_ANIM_DROWNING_PART1] = "CHAR_ANIM_DROWNING_PART1",
    [CHAR_ANIM_DROWNING_PART2] = "CHAR_ANIM_DROWNING_PART2",
    [CHAR_ANIM_WATER_DYING] = "CHAR_ANIM_WATER_DYING",
    [CHAR_ANIM_WATER_FORWARD_KB] = "CHAR_ANIM_WATER_FORWARD_KB",
    [CHAR_ANIM_FALL_FROM_WATER] = "CHAR_ANIM_FALL_FROM_WATER",
    [CHAR_ANIM_SWIM_PART1] = "CHAR_ANIM_SWIM_PART1",
    [CHAR_ANIM_SWIM_PART2] = "CHAR_ANIM_SWIM_PART2",
    [CHAR_ANIM_FLUTTERKICK] = "CHAR_ANIM_FLUTTERKICK",
    [CHAR_ANIM_WATER_ACTION_END] = "CHAR_ANIM_WATER_ACTION_END",
    [CHAR_ANIM_WATER_PICK_UP_OBJ] = "CHAR_ANIM_WATER_PICK_UP_OBJ",
    [CHAR_ANIM_WATER_GRAB_OBJ_PART2] = "CHAR_ANIM_WATER_GRAB_OBJ_PART2",
    [CHAR_ANIM_WATER_GRAB_OBJ_PART1] = "CHAR_ANIM_WATER_GRAB_OBJ_PART1",
    [CHAR_ANIM_WATER_THROW_OBJ] = "CHAR_ANIM_WATER_THROW_OBJ",
    [CHAR_ANIM_WATER_IDLE] = "CHAR_ANIM_WATER_IDLE",
    [CHAR_ANIM_WATER_STAR_DANCE] = "CHAR_ANIM_WATER_STAR_DANCE",
    [CHAR_ANIM_RETURN_FROM_WATER_STAR_DANCE] = "CHAR_ANIM_RETURN_FROM_WATER_STAR_DANCE",
    [CHAR_ANIM_GRAB_BOWSER] = "CHAR_ANIM_GRAB_BOWSER",
    [CHAR_ANIM_SWINGING_BOWSER] = "CHAR_ANIM_SWINGING_BOWSER",
    [CHAR_ANIM_RELEASE_BOWSER] = "CHAR_ANIM_RELEASE_BOWSER",
    [CHAR_ANIM_HOLDING_BOWSER] = "CHAR_ANIM_HOLDING_BOWSER",
    [CHAR_ANIM_HEAVY_THROW] = "CHAR_ANIM_HEAVY_THROW",
    [CHAR_ANIM_WALK_PANTING] = "CHAR_ANIM_WALK_PANTING",
    [CHAR_ANIM_WALK_WITH_HEAVY_OBJ] = "CHAR_ANIM_WALK_WITH_HEAVY_OBJ",
    [CHAR_ANIM_TURNING_PART1] = "CHAR_ANIM_TURNING_PART1",
    [CHAR_ANIM_TURNING_PART2] = "CHAR_ANIM_TURNING_PART2",
    [CHAR_ANIM_SLIDEFLIP_LAND] = "CHAR_ANIM_SLIDEFLIP_LAND",
    [CHAR_ANIM_SLIDEFLIP] = "CHAR_ANIM_SLIDEFLIP",
    [CHAR_ANIM_TRIPLE_JUMP_LAND] = "CHAR_ANIM_TRIPLE_JUMP_LAND",
    [CHAR_ANIM_TRIPLE_JUMP] = "CHAR_ANIM_TRIPLE_JUMP",
    [CHAR_ANIM_FIRST_PERSON] = "CHAR_ANIM_FIRST_PERSON",
    [CHAR_ANIM_IDLE_HEAD_LEFT] = "CHAR_ANIM_IDLE_HEAD_LEFT",
    [CHAR_ANIM_IDLE_HEAD_RIGHT] = "CHAR_ANIM_IDLE_HEAD_RIGHT",
    [CHAR_ANIM_IDLE_HEAD_CENTER] = "CHAR_ANIM_IDLE_HEAD_CENTER",
    [CHAR_ANIM_HANDSTAND_LEFT] = "CHAR_ANIM_HANDSTAND_LEFT",
    [CHAR_ANIM_HANDSTAND_RIGHT] = "CHAR_ANIM_HANDSTAND_RIGHT",
    [CHAR_ANIM_WAKE_FROM_SLEEP] = "CHAR_ANIM_WAKE_FROM_SLEEP",
    [CHAR_ANIM_WAKE_FROM_LYING] = "CHAR_ANIM_WAKE_FROM_LYING",
    [CHAR_ANIM_START_TIPTOE] = "CHAR_ANIM_START_TIPTOE",
    [CHAR_ANIM_SLIDEJUMP] = "CHAR_ANIM_SLIDEJUMP",
    [CHAR_ANIM_START_WALLKICK] = "CHAR_ANIM_START_WALLKICK",
    [CHAR_ANIM_STAR_DANCE] = "CHAR_ANIM_STAR_DANCE",
    [CHAR_ANIM_RETURN_FROM_STAR_DANCE] = "CHAR_ANIM_RETURN_FROM_STAR_DANCE",
    [CHAR_ANIM_FORWARD_SPINNING_FLIP] = "CHAR_ANIM_FORWARD_SPINNING_FLIP",
    [CHAR_ANIM_TRIPLE_JUMP_FLY] = "CHAR_ANIM_TRIPLE_JUMP_FLY",
    --]]
}

local VOICETABLE_TROLL = {
    [CHAR_SOUND_ATTACKED] = {'ouch.ogg', 'ouch2.ogg', 'ouch3.ogg', 'ouch4.ogg'},
    --[[
    [CHAR_SOUND_COUGHING1] = 'gah1.ogg',
    [CHAR_SOUND_COUGHING2] = 'gah1.ogg',
    [CHAR_SOUND_COUGHING3] = 'gah1.ogg',
    [CHAR_SOUND_DOH] = 'nyo.ogg',
    [CHAR_SOUND_DROWNING] = 'drowning.ogg',
    [CHAR_SOUND_DYING] = 'dying.ogg',
    [CHAR_SOUND_EEUH] = 'eeyup.ogg',
    [CHAR_SOUND_GROUND_POUND_WAH] = 'woah.ogg',
    --]]
    [CHAR_SOUND_HAHA] = 'hehehe.ogg',
    [CHAR_SOUND_HAHA_2] = 'hehehe.ogg',
    [CHAR_SOUND_HERE_WE_GO] = 'yippe_big.ogg',
    --[CHAR_SOUND_HOOHOO] = 'wehe.ogg',
    [CHAR_SOUND_HRMM] = 'eeyup.ogg',
    [CHAR_SOUND_IMA_TIRED] = 'eepy.ogg',
    [CHAR_SOUND_MAMA_MIA] = 'angy.ogg',
    --[CHAR_SOUND_LETS_A_GO] = 'letsgo.ogg',
    [CHAR_SOUND_ON_FIRE] = 'hothot.ogg',
    --[[
    [CHAR_SOUND_OOOF] = 'gah0.ogg',
    [CHAR_SOUND_OOOF2] = 'gah1.ogg',
    [CHAR_SOUND_PANTING] = 'pant.ogg',
    [CHAR_SOUND_PANTING_COLD] = 'pant.ogg',
    [CHAR_SOUND_PUNCH_HOO] = 'hit1.ogg',
    [CHAR_SOUND_PUNCH_WAH] = 'woah.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'hit1.ogg',
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'letsgo.ogg',
    [CHAR_SOUND_TWIRL_BOUNCE] = 'yipee2.ogg',
    [CHAR_SOUND_UH] = 'guh.ogg',
    [CHAR_SOUND_UH2] = 'guh.ogg',
    [CHAR_SOUND_WAAAOOOW] = 'falling.ogg',
    [CHAR_SOUND_WAH2] = 'hit1.ogg',
    [CHAR_SOUND_WHOA] = 'woah.ogg',
    [CHAR_SOUND_YAHOO] = 'whee.ogg',
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'yipee0.ogg', 'yipee1.ogg', 'yipee2.ogg'},
    [CHAR_SOUND_YAH_WAH_HOO] = {'jump0.ogg', 'jump1.ogg', 'jump2.ogg'},
    --]]
}

local function load_trollface()
    if _G.charSelectExists then
        _G.charSelect.character_add("Trollface", "He has a brother named Glue Library.", "birdekek", {r = 255, g = 255, b = 255}, E_MODEL_TROLLFACE, CT_LUIGI, TEX_TROLLFACE)
        _G.charSelect.character_add_animations(E_MODEL_TROLLFACE, ANIMTABLE_TROLLFACE)
        _G.charSelect.character_add_voice(E_MODEL_TROLLFACE, VOICETABLE_TROLL)

        --hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        --    if _G.charSelect.character_get_voice(m) == VOICETABLE_BALD then return _G.charSelect.voice.sound(m, sound) end
        --end)
        --hook_event(HOOK_MARIO_UPDATE, function (m)
        --    if _G.charSelect.character_get_voice(m) == VOICETABLE_BALD then return _G.charSelect.voice.snore(m) end
        --end)
    else
        djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn Character Select\nand Restart the server!", 6)
    end
end

hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
    if _G.charSelect.character_get_voice(m) == VOICETABLE_TROLL then return _G.charSelect.voice.sound(m, sound) end
end)

hook_event(HOOK_ON_MODS_LOADED, load_trollface)